console.log("etherpad_mediafragments...");

const current_media = document.getElementById("audio_file");
console.log(current_media);

function makeTimecode (secs) {
  let original_secs = secs;
  let h = Math.floor(secs / 3600);
  secs -= (h * 3600);
  let m = Math.floor(secs/60);
  secs -= (m * 60);
    let s = Math.floor(secs);
  secs -= s;
  let ret;
      if (h) {
    ret = `${h.toString().padStart(2, '0')}:${m.toString().padStart(2, '0')}:${s.toString().padStart(2, '0')}`;
      } else {
    ret =`${m.toString().padStart(2, '0')}:${s.toString().padStart(2, '0')}`;
      }
  // remaining secs is fractional part 0 < secs < 1
  if (secs) {
    ret += `.${secs.toFixed(3).slice(2)}`;
  }
  // console.log(`TC: ${original_secs} -> ${ret}`);
  return ret;
}

function togglePlayback () {
  if (current_media) {
    if (current_media.paused) {
      current_media.play();
    } else {
      current_media.pause();
    }
  }
}

function jump (time) {
  if (current_media) {
    current_media.currentTime += time;
  }
}

function pasteTimecode() {
  if (current_media) {
    let t = current_media.currentTime;
    let tc = makeTimecode(t);
    let link = `${current_media.src}#t=${tc}`;
    let alink = `<a href="#" onclick="document.getElementById('audio_file').currentTime=${t};">${tc}</a> <span contenteditable="true">...</span><br>`
    console.log(alink);
    let annotations_area = document.getElementById("annotations");
    annotations_area.innerHTML += "\n\n" + alink + "\n\n";
  }
}

// Add Keyboard shortcuts
document.addEventListener("keydown", function (e) {
  console.log("keydown", e);
  if ((e.ctrlKey || e.metaKey) && e.shiftKey) {
    if (e.key == "ArrowDown") {
      pasteTimecode();
      e.preventDefault(); e.stopPropagation();
    } else if (e.key == "ArrowLeft") {
      jump(-5);
      e.preventDefault(); e.stopPropagation();
    } else if (e.key == "ArrowRight") {
      jump(5);
      e.preventDefault(); e.stopPropagation();
    } else if (e.key == "ArrowUp") {
      togglePlayback();
      e.preventDefault(); e.stopPropagation();
    }
  }
}, true);
